## cppcheck 1.88

=== CMakeLists.txt ===
project(Cppcheck)
cmake_minimum_required(VERSION 2.8.11)

include(GNUInstallDirs)

include(cmake/versions.cmake REQUIRED)
include(cmake/options.cmake REQUIRED)
include(cmake/findDependencies.cmake REQUIRED)
include(cmake/compileroptions.cmake REQUIRED)
include(cmake/compilerDefinitions.cmake REQUIRED)
include(cmake/buildFiles.cmake REQUIRED)
include(cmake/cxx11.cmake REQUIRED)

use_cxx11()

file(GLOB cfgs "cfg/*.cfg")

if (BUILD_TESTS)
    enable_testing()
endif()

add_subdirectory(externals/tinyxml)
add_subdirectory(externals/simplecpp)
add_subdirectory(lib)   # CppCheck Library 
add_subdirectory(cli)   # Client application
add_subdirectory(test)  # Tests
ADD_SUBDIRECTORY(gui)   # Graphical application
ADD_SUBDIRECTORY(tools/triage)   # Triage tool

include(cmake/printInfo.cmake REQUIRED)

=== Makefile ===
# This file is generated by tools/dmake, do not edit.

# To compile with rules, use 'make HAVE_RULES=yes'
ifndef HAVE_RULES
    HAVE_RULES=no
endif

# use match compiler
ifeq ($(SRCDIR),build)
    $(warning Usage of SRCDIR to acticate match compiler is deprecated. Use MATCHCOMPILER=yes instead.)
    MATCHCOMPILER:=yes
endif
ifeq ($(MATCHCOMPILER),yes)
    ifdef VERIFY
        matchcompiler_S := $(shell python tools/matchcompiler.py --verify)
    else
        matchcompiler_S := $(shell python tools/matchcompiler.py)
    endif
    libcppdir:=build
else
    libcppdir:=lib
endif

ifdef CFGDIR
    CFG=-DCFGDIR=\"$(CFGDIR)\"
else
    CFG=
endif

RDYNAMIC=-rdynamic
# Set the CPPCHK_GLIBCXX_DEBUG flag. This flag is not used in release Makefiles.
# The _GLIBCXX_DEBUG define doesn't work in Cygwin or other Win32 systems.
ifndef COMSPEC
    ifdef ComSpec
        #### ComSpec is defined on some WIN32's.
        COMSPEC=$(ComSpec)
    endif # ComSpec
endif # COMSPEC

ifdef COMSPEC
    #### Maybe Windows
    ifndef CPPCHK_GLIBCXX_DEBUG
        CPPCHK_GLIBCXX_DEBUG=
    endif # !CPPCHK_GLIBCXX_DEBUG

    ifeq ($(MSYSTEM),MINGW32 MINGW64)
        LDFLAGS=-lshlwapi
    else
        RDYNAMIC=-lshlwapi
    endif
else # !COMSPEC
    uname_S := $(shell sh -c 'uname -s 2>/dev/null || echo not')

    ifeq ($(uname_S),Linux)
        ifndef CPPCHK_GLIBCXX_DEBUG
            CPPCHK_GLIBCXX_DEBUG=-D_GLIBCXX_DEBUG
        endif # !CPPCHK_GLIBCXX_DEBUG
    endif # Linux

    ifeq ($(uname_S),GNU/kFreeBSD)
        ifndef CPPCHK_GLIBCXX_DEBUG
            CPPCHK_GLIBCXX_DEBUG=-D_GLIBCXX_DEBUG
        endif # !CPPCHK_GLIBCXX_DEBUG
    endif # GNU/kFreeBSD

endif # COMSPEC

# Set the UNDEF_STRICT_ANSI flag to address compile time warnings
# with tinyxml2 and Cygwin.
ifdef COMSPEC
    uname_S := $(shell uname -s)

    ifneq (,$(findstring CYGWIN,$(uname_S)))
        UNDEF_STRICT_ANSI=-U__STRICT_ANSI__
    endif # CYGWIN
endif # COMSPEC

ifndef CXX
    CXX=g++
endif

ifeq (clang++, $(findstring clang++,$(CXX)))
    CPPCHK_GLIBCXX_DEBUG=
endif
ifndef CXXFLAGS
    CXXFLAGS=-std=c++0x -O2 -DNDEBUG -Wall -Wno-sign-compare
endif

ifeq (g++, $(findstring g++,$(CXX)))
    override CXXFLAGS += -std=c++0x
else ifeq (clang++, $(findstring clang++,$(CXX)))
    override CXXFLAGS += -std=c++0x
else ifeq ($(CXX), c++)
    ifeq ($(shell uname -s), Darwin)
        override CXXFLAGS += -std=c++0x
    endif
endif

ifeq ($(HAVE_RULES),yes)
    override CXXFLAGS += -DHAVE_RULES -DTIXML_USE_STL $(shell pcre-config --cflags)
    ifdef LIBS
        LIBS += $(shell pcre-config --libs)
    else
        LIBS=$(shell pcre-config --libs)
    endif
endif

ifndef PREFIX
    PREFIX=/usr
endif

ifndef INCLUDE_FOR_LIB
    INCLUDE_FOR_LIB=-Ilib -isystem externals -isystem externals/simplecpp -isystem externals/tinyxml
endif

ifndef INCLUDE_FOR_CLI
    INCLUDE_FOR_CLI=-Ilib -isystem externals/simplecpp -isystem externals/tinyxml
endif

ifndef INCLUDE_FOR_TEST
    INCLUDE_FOR_TEST=-Ilib -Icli -isystem externals/simplecpp -isystem externals/tinyxml
endif

BIN=$(DESTDIR)$(PREFIX)/bin

# For 'make man': sudo apt-get install xsltproc docbook-xsl docbook-xml on Linux
DB2MAN?=/usr/share/sgml/docbook/stylesheet/xsl/nwalsh/manpages/docbook.xsl
XP=xsltproc -''-nonet -''-param man.charmap.use.subset "0"
MAN_SOURCE=man/cppcheck.1.xml


###### Object Files

LIBOBJ =      $(libcppdir)/analyzerinfo.o \
              $(libcppdir)/astutils.o \
              $(libcppdir)/check.o \
              $(libcppdir)/check64bit.o \
              $(libcppdir)/checkassert.o \
              $(libcppdir)/checkautovariables.o \
              $(libcppdir)/checkbool.o \
              $(libcppdir)/checkboost.o \
              $(libcppdir)/checkbufferoverrun.o \
              $(libcppdir)/checkclass.o \
              $(libcppdir)/checkcondition.o \
              $(libcppdir)/checkexceptionsafety.o \
              $(libcppdir)/checkfunctions.o \
              $(libcppdir)/checkinternal.o \
              $(libcppdir)/checkio.o \
              $(libcppdir)/checkleakautovar.o \
              $(libcppdir)/checkmemoryleak.o \
              $(libcppdir)/checknullpointer.o \
              $(libcppdir)/checkother.o \
              $(libcppdir)/checkpostfixoperator.o \
              $(libcppdir)/checksizeof.o \
              $(libcppdir)/checkstl.o \
              $(libcppdir)/checkstring.o \
              $(libcppdir)/checktype.o \
              $(libcppdir)/checkuninitvar.o \
              $(libcppdir)/checkunusedfunctions.o \
              $(libcppdir)/checkunusedvar.o \
              $(libcppdir)/checkvaarg.o \
              $(libcppdir)/cppcheck.o \
              $(libcppdir)/ctu.o \
              $(libcppdir)/errorlogger.o \
              $(libcppdir)/importproject.o \
              $(libcppdir)/library.o \
              $(libcppdir)/mathlib.o \
              $(libcppdir)/path.o \
              $(libcppdir)/pathmatch.o \
              $(libcppdir)/platform.o \
              $(libcppdir)/preprocessor.o \
              $(libcppdir)/settings.o \
              $(libcppdir)/suppressions.o \
              $(libcppdir)/symboldatabase.o \
              $(libcppdir)/templatesimplifier.o \
              $(libcppdir)/timer.o \
              $(libcppdir)/token.o \
              $(libcppdir)/tokenize.o \
              $(libcppdir)/tokenlist.o \
              $(libcppdir)/valueflow.o

EXTOBJ =      externals/simplecpp/simplecpp.o \
              externals/tinyxml/tinyxml2.o

CLIOBJ =      cli/cmdlineparser.o \
              cli/cppcheckexecutor.o \
              cli/filelister.o \
              cli/main.o \
              cli/threadexecutor.o

TESTOBJ =     test/options.o \
              test/test64bit.o \
              test/testassert.o \
              test/testastutils.o \
              test/testautovariables.o \
              test/testbool.o \
              test/testboost.o \
              test/testbufferoverrun.o \
              test/testcharvar.o \
              test/testclass.o \
              test/testcmdlineparser.o \
              test/testcondition.o \
              test/testconstructors.o \
              test/testcppcheck.o \
              test/testerrorlogger.o \
              test/testexceptionsafety.o \
              test/testfilelister.o \
              test/testfunctions.o \
              test/testgarbage.o \
              test/testimportproject.o \
              test/testincompletestatement.o \
              test/testinternal.o \
              test/testio.o \
              test/testleakautovar.o \
              test/testlibrary.o \
              test/testmathlib.o \
              test/testmemleak.o \
              test/testnullpointer.o \
              test/testoptions.o \
              test/testother.o \
              test/testpath.o \
              test/testpathmatch.o \
              test/testplatform.o \
              test/testpostfixoperator.o \
              test/testpreprocessor.o \
              test/testrunner.o \
              test/testsamples.o \
              test/testsimplifytemplate.o \
              test/testsimplifytokens.o \
              test/testsimplifytypedef.o \
              test/testsimplifyusing.o \
              test/testsizeof.o \
              test/teststl.o \
              test/teststring.o \
              test/testsuite.o \
              test/testsuppressions.o \
              test/testsymboldatabase.o \
              test/testthreadexecutor.o \
              test/testtimer.o \
              test/testtoken.o \
              test/testtokenize.o \
              test/testtokenlist.o \
              test/testtype.o \
              test/testuninitvar.o \
              test/testunusedfunctions.o \
              test/testunusedprivfunc.o \
              test/testunusedvar.o \
              test/testvaarg.o \
              test/testvalueflow.o \
              test/testvarid.o

.PHONY: run-dmake tags


###### Targets

cppcheck: $(LIBOBJ) $(CLIOBJ) $(EXTOBJ)
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) -o $@ $^ $(LIBS) $(LDFLAGS) $(RDYNAMIC)

all:	cppcheck testrunner

testrunner: $(TESTOBJ) $(LIBOBJ) $(EXTOBJ) cli/threadexecutor.o cli/cmdlineparser.o cli/cppcheckexecutor.o cli/filelister.o
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) -o $@ $^ $(LIBS) $(LDFLAGS) $(RDYNAMIC)

test:	all
	./testrunner

check:	all
	./testrunner -q

checkcfg:	cppcheck validateCFG
	./test/cfg/runtests.sh

dmake:	tools/dmake.o cli/filelister.o $(libcppdir)/pathmatch.o $(libcppdir)/path.o externals/simplecpp/simplecpp.o
	$(CXX) $(CXXFLAGS) -o $@ $^ $(LDFLAGS)

run-dmake: dmake
	./dmake

generate_cfg_tests: tools/generate_cfg_tests.o $(EXTOBJ)
	g++ -isystem externals/tinyxml -o generate_cfg_tests tools/generate_cfg_tests.o $(EXTOBJ)
clean:
	rm -f build/*.o lib/*.o cli/*.o test/*.o tools/*.o externals/*/*.o testrunner dmake cppcheck cppcheck.exe cppcheck.1

man:	man/cppcheck.1

man/cppcheck.1:	$(MAN_SOURCE)

	$(XP) $(DB2MAN) $(MAN_SOURCE)

tags:
	ctags -R --exclude=doxyoutput --exclude=test/cfg --exclude=test/synthetic cli externals gui lib test

install: cppcheck
	install -d ${BIN}
	install cppcheck ${BIN}
	install addons/*.py ${BIN}
	install addons/*/*.py ${BIN}
	install htmlreport/cppcheck-htmlreport ${BIN}
ifdef CFGDIR 
	install -d ${DESTDIR}${CFGDIR}
	install -m 644 cfg/* ${DESTDIR}${CFGDIR}
endif

uninstall:
	@if test -d ${BIN}; then \
	  files="cppcheck cppcheck-htmlreport \
	    `ls -d addons/*.py addons/*/*.py 2>/dev/null | sed 's,^.*/,,'`"; \
	  echo '(' cd ${BIN} '&&' rm -f $$files ')'; \
	  ( cd ${BIN} && rm -f $$files ); \
	fi
ifdef CFGDIR 
	@if test -d ${DESTDIR}${CFGDIR}; then \
	  files="`cd cfg 2>/dev/null && ls`"; \
	  if test -n "$$files"; then \
	    echo '(' cd ${DESTDIR}${CFGDIR} '&&' rm -f $$files ')'; \
	    ( cd ${DESTDIR}${CFGDIR} && rm -f $$files ); \
	  fi; \
	fi
endif

# Validation of library files:
ConfigFiles := $(wildcard cfg/*.cfg)
ConfigFilesCHECKED := $(patsubst %.cfg,%.checked,$(ConfigFiles))
.PHONY: validateCFG
%.checked:%.cfg
	xmllint --noout --relaxng cfg/cppcheck-cfg.rng $<
validateCFG: ${ConfigFilesCHECKED}

# Validation of platforms files:
PlatformFiles := $(wildcard platforms/*.xml)
PlatformFilesCHECKED := $(patsubst %.xml,%.checked,$(PlatformFiles))
.PHONY: validatePlatforms
%.checked:%.xml
	xmllint --noout --relaxng platforms/cppcheck-platforms.rng $<
validatePlatforms: ${PlatformFilesCHECKED}

# Validate XML output (to detect regressions)
/tmp/errorlist.xml: cppcheck
	./cppcheck --errorlist >$@
/tmp/example.xml: cppcheck
	./cppcheck --xml --enable=all --inconclusive --suppress=operatorEqVarError:*check.h -j 4 cli externals gui lib test 2>/tmp/example.xml
createXMLExamples:/tmp/errorlist.xml /tmp/example.xml
.PHONY: validateXML
validateXML: createXMLExamples
	xmllint --noout --relaxng cppcheck-errors.rng /tmp/errorlist.xml
	xmllint --noout --relaxng cppcheck-errors.rng /tmp/example.xml

checkCWEEntries: /tmp/errorlist.xml
	./tools/listErrorsWithoutCWE.py -F /tmp/errorlist.xml
###### Build

$(libcppdir)/analyzerinfo.o: lib/analyzerinfo.cpp lib/analyzerinfo.h lib/config.h lib/errorlogger.h lib/suppressions.h lib/importproject.h lib/platform.h lib/utils.h lib/path.h
	$(CXX) ${INCLUDE_FOR_LIB} $(CPPFLAGS) $(CFG) $(CXXFLAGS) $(UNDEF_STRICT_ANSI) -c -o $(libcppdir)/analyzerinfo.o $(libcppdir)/analyzerinfo.cpp

$(libcppdir)/astutils.o: lib/astutils.cpp lib/astutils.h lib/errorlogger.h lib/config.h lib/suppressions.h lib/library.h lib/mathlib.h lib/standards.h lib/settings.h lib/importproject.h lib/platform.h lib/utils.h lib/timer.h lib/symboldatabase.h lib/token.h lib/valueflow.h lib/templatesimplifier.h
	$(CXX) ${INCLUDE_FOR_LIB} $(CPPFLAGS) $(CFG) $(CXXFLAGS) $(UNDEF_STRICT_ANSI) -c -o $(libcppdir)/astutils.o $(libcppdir)/astutils.cpp

$(libcppdir)/check.o: lib/check.cpp lib/check.h lib/config.h lib/errorlogger.h lib/suppressions.h lib/settings.h lib/importproject.h lib/platform.h lib/utils.h lib/library.h lib/mathlib.h lib/standards.h lib/timer.h lib/token.h lib/valueflow.h lib/templatesimplifier.h lib/tokenize.h lib/tokenlist.h

=== requirements.txt ===
pcre,ftp://ftp.csx.cam.ac.uk/pub/software/programming/pcre/pcre-8.39.tar.bz2 -H sha256:b858099f82483031ee02092711689e7245586ada49e534a06e678b8ea9549e8b

=== cli/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/lib/)
include_directories(SYSTEM ${PROJECT_SOURCE_DIR}/externals/tinyxml/)
include_directories(${PROJECT_SOURCE_DIR}/externals/simplecpp/)

file(GLOB hdrs "*.h")
file(GLOB srcs "*.cpp")
file(GLOB mainfile "main.cpp")
list(REMOVE_ITEM srcs ${mainfile})

add_library(cli_objs OBJECT ${hdrs} ${srcs}) 
add_executable(cppcheck ${hdrs} ${mainfile} $<TARGET_OBJECTS:cli_objs> $<TARGET_OBJECTS:lib_objs> $<TARGET_OBJECTS:tinyxml_objs> $<TARGET_OBJECTS:simplecpp_objs>)
if (HAVE_RULES)
    find_library(PCRE_LIBRARY pcre)
    target_link_libraries(cppcheck ${PCRE_LIBRARY})
    find_path(PCRE_INCLUDE pcre.h)
    target_include_directories(cppcheck PUBLIC ${PCRE_INCLUDE})
endif()
if (WIN32 AND NOT BORLAND)
    target_link_libraries(cppcheck Shlwapi.lib)
endif()

install(TARGETS cppcheck
    RUNTIME DESTINATION ${CMAKE_INSTALL_FULL_BINDIR}
    COMPONENT applications)

install(FILES ${cfgs}
   DESTINATION ${CFGDIR}/
   COMPONENT headers)

=== debian/changelog ===
cppcheck (1.88-1) unstable; urgency=medium

  * New upstream release.

 -- Joachim Reichel <reichel@debian.org>  Wed, 03 Jul 2019 21:07:06 +0200

cppcheck (1.87-1) unstable; urgency=medium

  * New upstream release.
  * Add Rules-Requires-Root: no to debian/control.

 -- Joachim Reichel <reichel@debian.org>  Sat, 02 Mar 2019 16:37:27 +0100

=== debian/control ===
Source: cppcheck
Section: devel
Priority: optional
Maintainer: Joachim Reichel <reichel@debian.org>
Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.15.7~), xsltproc, docbook-xsl,
  docbook-xml, libpcre3-dev, libtinyxml2-dev (>= 6.2.0+dfsg), qt5-qmake, qtbase5-dev,
  qtbase5-dev-tools, gdb, dh-python, python3-all
Standards-Version: 4.3.0
Rules-Requires-Root: no
Homepage: http://sourceforge.net/p/cppcheck/wiki/Home/
X-Python3-Version: >= 3.5

Package: cppcheck
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, python3-pygments
Suggests: cppcheck-gui
Description: tool for static C/C++ code analysis (CLI)
 Cppcheck is a command-line tool that tries to detect bugs that your
 C/C++ compiler doesn't see. It is versatile, and can check non-standard
 code including various compiler extensions, inline assembly code, etc.
 Its internal preprocessor can handle includes, macros, and several
 preprocessor commands. While Cppcheck is highly configurable,
 you can start using it just by giving it a path to the source code.
 .
 It includes checks for:
  * pointers to out-of-scope auto variables;
  * assignment of auto variables to an effective parameter of a function;
  * out-of-bounds errors in arrays and STL;
  * missing class constructors;
  * variables not initialized by a constructor;
  * use of memset, memcpy, etcetera on a class;
  * non-virtual destructors for base classes;
  * operator= not returning a constant reference to itself;
  * use of deprecated functions (mktemp, gets, scanf);
  * exceptions thrown in destructors;
  * memory leaks in class or function variables;
  * C-style pointer cast in C++ code;
  * redundant if;
  * misuse of the strtol or sprintf functions;
  * unsigned division or division by zero;
  * unused functions and struct members;
  * passing parameters by value;
  * misuse of signed char variables;
  * unusual pointer arithmetic (such as "abc" + 'd');
  * dereferenced null pointers;
  * incomplete statements;
  * misuse of iterators when iterating through a container;
  * dereferencing of erased iterators;
  * use of invalidated vector iterators/pointers;
 .
 This package contains the command-line interface for cppcheck.

Package: cppcheck-gui
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: python3, clang
Description: tool for static C/C++ code analysis (GUI)
 Cppcheck is a command-line tool that tries to detect bugs that your
 C/C++ compiler doesn't see. It is versatile, and can check non-standard
 code including various compiler extensions, inline assembly code, etc.
 Its internal preprocessor can handle includes, macros, and several
 preprocessor commands. While Cppcheck is highly configurable,
 you can start using it just by giving it a path to the source code.
 .
 It includes checks for:
  * pointers to out-of-scope auto variables;
  * assignment of auto variables to an effective parameter of a function;
  * out-of-bounds errors in arrays and STL;
  * missing class constructors;
  * variables not initialized by a constructor;
  * use of memset, memcpy, etcetera on a class;
  * non-virtual destructors for base classes;
  * operator= not returning a constant reference to itself;
  * use of deprecated functions (mktemp, gets, scanf);
  * exceptions thrown in destructors;
  * memory leaks in class or function variables;
  * C-style pointer cast in C++ code;
  * redundant if;
  * misuse of the strtol or sprintf functions;
  * unsigned division or division by zero;
  * unused functions and struct members;
  * passing parameters by value;
  * misuse of signed char variables;
  * unusual pointer arithmetic (such as "abc" + 'd');
  * dereferenced null pointers;
  * incomplete statements;
  * misuse of iterators when iterating through a container;
  * dereferencing of erased iterators;
  * use of invalidated vector iterators/pointers
 .
 This package contains the graphical user interface for cppcheck.

=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE=1

# for DEB_VERSION_UPSTREAM
include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

DB2MAN      = /usr/share/sgml/docbook/stylesheet/xsl/nwalsh/manpages/docbook.xsl
XP          = xsltproc -''-nonet -''-param man.charmap.use.subset "0"
DESTDIR     = $(CURDIR)/debian/cppcheck
DESTDIR_GUI = $(CURDIR)/debian/cppcheck-gui

override_dh_auto_build:
	echo ld $LDFLAGS
	echo env
	set
	[ -f externals/tinyxml ] || mv externals/tinyxml externals/tinyxml.disabled
	dh_auto_build -- CFGDIR=/usr/share/cppcheck/cfg HAVE_RULES=yes LIBS=-ltinyxml2 \
		INCLUDE_FOR_LIB="-Ilib -Iexternals -Iexternals/simplecpp" \
		INCLUDE_FOR_CLI="-Ilib -Iexternals/simplecpp" \
		INCLUDE_FOR_TEST="-Ilib -Icli -Iexternals/simplecpp"
	$(XP) $(DB2MAN) man/cppcheck.1.xml
	cd gui; qmake -qt=5 HAVE_RULES=yes
	sed -i -e 's/^CC\>/#CC/;s/^CXX\>/#CXX/;s/^CFLAGS *=/CFLAGS += $$(CPPFLAGS)/;s/^CXXFLAGS *=/CXXFLAGS += $$(CPPFLAGS)/;s/^LFLAGS *=/LFLAGS += $$(LDFLAGS)/' gui/Makefile
	dh_auto_build -- -C gui HAVE_RULES=yes CC="$(CC)" CXX="$(CXX)"
	sed -e "s/1.70/$(DEB_VERSION_UPSTREAM)/" debian/cppcheck-htmlreport.1.in >debian/cppcheck-htmlreport.1

override_dh_auto_clean:
	dh_auto_clean
	[ ! -f gui/Makefile ] || $(MAKE) -C gui clean
	rm -f gui/Makefile gui/cppcheck-gui gui/.qmake.stash
	rm -f debian/cppcheck-htmlreport.1
	[ ! -d externals/tinyxml.disabled ] || mv externals/tinyxml.disabled externals/tinyxml

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test -- CFGDIR=/usr/share/cppcheck/cfg HAVE_RULES=yes LIBS=-ltinyxml2 \
		INCLUDE_FOR_LIB="-Ilib -Iexternals -Iexternals/simplecpp" \
		INCLUDE_FOR_CLI="-Ilib -Iexternals/simplecpp" \
		INCLUDE_FOR_TEST="-Ilib -Icli -Iexternals/simplecpp"
endif

override_dh_auto_install:
	install -d ${DESTDIR}/usr/bin
	install cppcheck ${DESTDIR}/usr/bin
	install -d ${DESTDIR}/usr/share/cppcheck/cfg
	install -m 644 cfg/* ${DESTDIR}/usr/share/cppcheck/cfg
	install htmlreport/cppcheck-htmlreport ${DESTDIR}/usr/bin
	install -d ${DESTDIR}/usr/share/man/man1
	install debian/cppcheck-htmlreport.1 ${DESTDIR}/usr/share/man/man1
	install -d ${DESTDIR_GUI}/usr/bin
	install gui/cppcheck-gui ${DESTDIR_GUI}/usr/bin

override_dh_python3:
	dh_python3 --shebang=/usr/bin/python3

%:
	dh $@ --with python3

## cppcheck 1.89

=== Makefile ===
--- 
+++ 
@@ -21,10 +21,10 @@
     libcppdir:=lib
 endif
 
-ifdef CFGDIR
-    CFG=-DCFGDIR=\"$(CFGDIR)\"
+ifdef FILESDIR
+    CPPFILESDIR=-DFILESDIR=\"$(FILESDIR)\"
 else
-    CFG=
+    CPPFILESDIR=
 endif
 
 RDYNAMIC=-rdynamic
@@ -85,6 +85,15 @@
 ifndef CXXFLAGS
     CXXFLAGS=-std=c++0x -O2 -DNDEBUG -Wall -Wno-sign-compare
 endif
+
+# Increase stack size for Cygwin builds to avoid segmentation fault in limited recursive tests.
+ifdef COMSPEC
+    uname_S := $(shell uname -s)
+
+    ifneq (,$(findstring CYGWIN,$(uname_S)))
+        CXXFLAGS+=-Wl,--stack,8388608
+    endif # CYGWIN
+endif # COMSPEC
 
 ifeq (g++, $(findstring g++,$(CXX)))
     override CXXFLAGS += -std=c++0x
@@ -294,21 +303,31 @@
 install: cppcheck
 	install -d ${BIN}
 	install cppcheck ${BIN}
-	install addons/*.py ${BIN}
-	install addons/*/*.py ${BIN}
 	install htmlreport/cppcheck-htmlreport ${BIN}
-ifdef CFGDIR 
-	install -d ${DESTDIR}${CFGDIR}
-	install -m 644 cfg/* ${DESTDIR}${CFGDIR}
+ifdef FILESDIR
+	install -d ${DESTDIR}${FILESDIR}
+	install -d ${DESTDIR}${FILESDIR}/addons
+	install -m 644 addons/*.py ${DESTDIR}${FILESDIR}/addons
+	install -d ${DESTDIR}${FILESDIR}/cfg
+	install -m 644 cfg/*.cfg ${DESTDIR}${FILESDIR}/cfg
+	install -d ${DESTDIR}${FILESDIR}/platforms
+	install -m 644 platforms/*.xml ${DESTDIR}${FILESDIR}/platforms
+else
+	$(error FILESDIR must be set!)
 endif
 
 uninstall:
 	@if test -d ${BIN}; then \
-	  files="cppcheck cppcheck-htmlreport \
-	    `ls -d addons/*.py addons/*/*.py 2>/dev/null | sed 's,^.*/,,'`"; \
+	  files="cppcheck cppcheck-htmlreport"; \
 	  echo '(' cd ${BIN} '&&' rm -f $$files ')'; \
 	  ( cd ${BIN} && rm -f $$files ); \
 	fi
+ifdef FILESDIR 
+	@if test -d ${DESTDIR}${FILESDIR}; then \
+	  echo rm -rf ${DESTDIR}${FILESDIR}; \
+	  rm -rf ${DESTDIR}${FILESDIR}; \
+	fi
+endif
 ifdef CFGDIR 
 	@if test -d ${DESTDIR}${CFGDIR}; then \
 	  files="`cd cfg 2>/dev/null && ls`"; \
@@ -348,12 +367,9 @@
 
 checkCWEEntries: /tmp/errorlist.xml
 	./tools/listErrorsWithoutCWE.py -F /tmp/errorlist.xml
+
 ###### Build
 
 $(libcppdir)/analyzerinfo.o: lib/analyzerinfo.cpp lib/analyzerinfo.h lib/config.h lib/errorlogger.h lib/suppressions.h lib/importproject.h lib/platform.h lib/utils.h lib/path.h
-	$(CXX) ${INCLUDE_FOR_LIB} $(CPPFLAGS) $(CFG) $(CXXFLAGS) $(UNDEF_STRICT_ANSI) -c -o $(libcppdir)/analyzerinfo.o $(libcppdir)/analyzerinfo.cpp
-
-$(libcppdir)/astutils.o: lib/astutils.cpp lib/astutils.h lib/errorlogger.h lib/config.h lib/suppressions.h lib/library.h lib/mathlib.h lib/standards.h lib/settings.h lib/importproject.h lib/platform.h lib/utils.h lib/timer.h lib/symboldatabase.h lib/token.h lib/valueflow.h lib/templatesimplifier.h
-	$(CXX) ${INCLUDE_FOR_LIB} $(CPPFLAGS) $(CFG) $(CXXFLAGS) $(UNDEF_STRICT_ANSI) -c -o $(libcppdir)/astutils.o $(libcppdir)/astutils.cpp
-
-$(libcppdir)/check.o: lib/check.cpp lib/check.h lib/config.h lib/errorlogger.h lib/suppressions.h lib/settings.h lib/importproject.h lib/platform.h lib/utils.h lib/library.h lib/mathlib.h lib/standards.h lib/timer.h lib/token.h lib/valueflow.h lib/templatesimplifier.h lib/tokenize.h lib/tokenlist.h
+	$(CXX) ${INCLUDE_FOR_LIB} $(CPPFLAGS) $(CPPFILESDIR) $(CXXFLAGS) $(UNDEF_STRICT_ANSI) -c -o $(libcppdir)/analyzerinfo.o $(libcppdir)/analyzerinfo.cpp
+

=== test/CMakeLists.txt ===
if (BUILD_TESTS)

    include_directories(${PROJECT_SOURCE_DIR}/lib/ ${PROJECT_SOURCE_DIR}/cli/)
    include_directories(SYSTEM ${PROJECT_SOURCE_DIR}/externals/tinyxml)
    include_directories(${PROJECT_SOURCE_DIR}/externals/simplecpp/)

    file(GLOB hdrs "*.h")
    file(GLOB srcs "*.cpp")

    add_executable(testrunner ${hdrs} ${srcs} $<TARGET_OBJECTS:lib_objs> $<TARGET_OBJECTS:cli_objs> $<TARGET_OBJECTS:tinyxml_objs> $<TARGET_OBJECTS:simplecpp_objs>)
    if (HAVE_RULES)
        target_link_libraries(testrunner pcre)
    endif()

    add_custom_target(copy_cfg ALL
        COMMENT "Copying cfg files")
    add_custom_command(
        TARGET copy_cfg
        COMMAND ${CMAKE_COMMAND} -E copy_directory "${PROJECT_SOURCE_DIR}/cfg"
            "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/cfg")

    if (WIN32 AND NOT BORLAND)
        target_link_libraries(testrunner Shlwapi.lib)
    endif()

    add_dependencies(testrunner copy_cfg)

    add_test(NAME testrunner COMMAND testrunner WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})

    add_custom_target(check COMMAND $<TARGET_FILE:testrunner> -q WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
    add_dependencies(check testrunner)

endif()

=== debian/changelog ===
cppcheck (1.89-4) unstable; urgency=medium

  * Add patch bug-9359: Loosen check to ignore char vs signed char vs
    unsigned char.

 -- Joachim Reichel <reichel@debian.org>  Sat, 05 Oct 2019 12:46:53 +0200

cppcheck (1.89-3) unstable; urgency=medium

  * Fix patch fix-default-settings: do not use FILESDIR in tryLoadLibrary(),
    use separate cppcheck binary with different FILESDIR setting for tests.

 -- Joachim Reichel <reichel@debian.org>  Tue, 01 Oct 2019 03:07:56 +0200

cppcheck (1.89-2) unstable; urgency=medium

  * Fix patch fix-default-settings: remove "cfg" path component from
    FILESDIR, use FILESDIR in tryLoadLibrary().

 -- Joachim Reichel <reichel@debian.org>  Mon, 30 Sep 2019 21:33:05 +0200

cppcheck (1.89-1) unstable; urgency=medium

  * New upstream release.
  * Remove redundant X-Python-Version: from debian/control.
  * Update Standards-Version to 4.4.1 (no changes needed).

 -- Joachim Reichel <reichel@debian.org>  Mon, 30 Sep 2019 19:45:13 +0200

=== debian/control ===
--- 
+++ 
@@ -5,10 +5,9 @@
 Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.15.7~), xsltproc, docbook-xsl,
   docbook-xml, libpcre3-dev, libtinyxml2-dev (>= 6.2.0+dfsg), qt5-qmake, qtbase5-dev,
   qtbase5-dev-tools, gdb, dh-python, python3-all
-Standards-Version: 4.3.0
+Standards-Version: 4.4.1
 Rules-Requires-Root: no
 Homepage: http://sourceforge.net/p/cppcheck/wiki/Home/
-X-Python3-Version: >= 3.5
 
 Package: cppcheck
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -13,11 +13,8 @@
 DESTDIR_GUI = $(CURDIR)/debian/cppcheck-gui
 
 override_dh_auto_build:
-	echo ld $LDFLAGS
-	echo env
-	set
-	[ -f externals/tinyxml ] || mv externals/tinyxml externals/tinyxml.disabled
-	dh_auto_build -- CFGDIR=/usr/share/cppcheck/cfg HAVE_RULES=yes LIBS=-ltinyxml2 \
+	[ ! -d externals/tinyxml ] || mv externals/tinyxml externals/tinyxml.disabled
+	dh_auto_build -- MATCHCOMPILER=yes FILESDIR=/usr/share/cppcheck HAVE_RULES=yes LIBS=-ltinyxml2 \
 		INCLUDE_FOR_LIB="-Ilib -Iexternals -Iexternals/simplecpp" \
 		INCLUDE_FOR_CLI="-Ilib -Iexternals/simplecpp" \
 		INCLUDE_FOR_TEST="-Ilib -Icli -Iexternals/simplecpp"
@@ -32,14 +29,20 @@
 	[ ! -f gui/Makefile ] || $(MAKE) -C gui clean
 	rm -f gui/Makefile gui/cppcheck-gui gui/.qmake.stash
 	rm -f debian/cppcheck-htmlreport.1
+	rm -rf build
+	rm -f cppcheck.regular_build
 	[ ! -d externals/tinyxml.disabled ] || mv externals/tinyxml.disabled externals/tinyxml
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-	dh_auto_test -- CFGDIR=/usr/share/cppcheck/cfg HAVE_RULES=yes LIBS=-ltinyxml2 \
+	# backup main binary with FILESDIR=/usr/share/cppcheck
+	mv cppcheck cppcheck.regular_build 
+	dh_auto_test -- MATCHCOMPILER=yes FILESDIR=$(CURDIR) HAVE_RULES=yes LIBS=-ltinyxml2 \
 		INCLUDE_FOR_LIB="-Ilib -Iexternals -Iexternals/simplecpp" \
 		INCLUDE_FOR_CLI="-Ilib -Iexternals/simplecpp" \
 		INCLUDE_FOR_TEST="-Ilib -Icli -Iexternals/simplecpp"
+	# restore main binary with FILESDIR=/usr/share/cppcheck
+	mv cppcheck.regular_build cppcheck
 endif
 
 override_dh_auto_install:

## cppcheck 1.90

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,7 +13,9 @@
 
 use_cxx11()
 
+file(GLOB addons "addons/*.py")
 file(GLOB cfgs "cfg/*.cfg")
+file(GLOB platforms "platforms/*.xml")
 
 if (BUILD_TESTS)
     enable_testing()

=== Makefile ===
--- 
+++ 
@@ -5,16 +5,32 @@
     HAVE_RULES=no
 endif
 
+ifndef USE_Z3
+    USE_Z3=no
+endif
+
+ifeq ($(USE_Z3),yes)
+    CPPFLAGS += -DUSE_Z3
+    LIBS += -lz3
+endif
 # use match compiler
 ifeq ($(SRCDIR),build)
-    $(warning Usage of SRCDIR to acticate match compiler is deprecated. Use MATCHCOMPILER=yes instead.)
+    $(warning Usage of SRCDIR to activate match compiler is deprecated. Use MATCHCOMPILER=yes instead.)
     MATCHCOMPILER:=yes
 endif
 ifeq ($(MATCHCOMPILER),yes)
+    # Find available Python interpreter
+    PYTHON_INTERPRETER := $(shell which python)
+    ifndef PYTHON_INTERPRETER
+        PYTHON_INTERPRETER := $(shell which python3)
+    endif
+    ifndef PYTHON_INTERPRETER
+        $(error Did not find a Python interpreter)
+    endif
     ifdef VERIFY
-        matchcompiler_S := $(shell python tools/matchcompiler.py --verify)
+        matchcompiler_S := $(shell $(PYTHON_INTERPRETER) tools/matchcompiler.py --verify)
     else
-        matchcompiler_S := $(shell python tools/matchcompiler.py)
+        matchcompiler_S := $(shell $(PYTHON_INTERPRETER) tools/matchcompiler.py)
     endif
     libcppdir:=build
 else
@@ -171,13 +187,16 @@
               $(libcppdir)/cppcheck.o \
               $(libcppdir)/ctu.o \
               $(libcppdir)/errorlogger.o \
+              $(libcppdir)/exprengine.o \
               $(libcppdir)/importproject.o \
               $(libcppdir)/library.o \
               $(libcppdir)/mathlib.o \
               $(libcppdir)/path.o \
+              $(libcppdir)/pathanalysis.o \
               $(libcppdir)/pathmatch.o \
               $(libcppdir)/platform.o \
               $(libcppdir)/preprocessor.o \
+              $(libcppdir)/programmemory.o \
               $(libcppdir)/settings.o \
               $(libcppdir)/suppressions.o \
               $(libcppdir)/symboldatabase.o \
@@ -213,6 +232,7 @@
               test/testcppcheck.o \
               test/testerrorlogger.o \
               test/testexceptionsafety.o \
+              test/testexprengine.o \
               test/testfilelister.o \
               test/testfunctions.o \
               test/testgarbage.o \
@@ -345,6 +365,7 @@
 %.checked:%.cfg
 	xmllint --noout --relaxng cfg/cppcheck-cfg.rng $<
 validateCFG: ${ConfigFilesCHECKED}
+	xmllint --noout cfg/cppcheck-cfg.rng
 
 # Validation of platforms files:
 PlatformFiles := $(wildcard platforms/*.xml)
@@ -358,18 +379,9 @@
 /tmp/errorlist.xml: cppcheck
 	./cppcheck --errorlist >$@
 /tmp/example.xml: cppcheck
-	./cppcheck --xml --enable=all --inconclusive --suppress=operatorEqVarError:*check.h -j 4 cli externals gui lib test 2>/tmp/example.xml
+	./cppcheck --xml --enable=all --inconclusive --suppress=operatorEqVarError:*check.h --max-configs=1 -j 4 cli externals gui lib test 2>/tmp/example.xml
 createXMLExamples:/tmp/errorlist.xml /tmp/example.xml
 .PHONY: validateXML
 validateXML: createXMLExamples
+	xmllint --noout cppcheck-errors.rng
 	xmllint --noout --relaxng cppcheck-errors.rng /tmp/errorlist.xml
-	xmllint --noout --relaxng cppcheck-errors.rng /tmp/example.xml
-
-checkCWEEntries: /tmp/errorlist.xml
-	./tools/listErrorsWithoutCWE.py -F /tmp/errorlist.xml
-
-###### Build
-
-$(libcppdir)/analyzerinfo.o: lib/analyzerinfo.cpp lib/analyzerinfo.h lib/config.h lib/errorlogger.h lib/suppressions.h lib/importproject.h lib/platform.h lib/utils.h lib/path.h
-	$(CXX) ${INCLUDE_FOR_LIB} $(CPPFLAGS) $(CPPFILESDIR) $(CXXFLAGS) $(UNDEF_STRICT_ANSI) -c -o $(libcppdir)/analyzerinfo.o $(libcppdir)/analyzerinfo.cpp
-

=== cli/CMakeLists.txt ===
--- 
+++ 
@@ -23,6 +23,15 @@
     RUNTIME DESTINATION ${CMAKE_INSTALL_FULL_BINDIR}
     COMPONENT applications)
 
+install(FILES ${addons}
+   DESTINATION ${FILESDIR}/addons
+   COMPONENT headers)
+
 install(FILES ${cfgs}
-   DESTINATION ${CFGDIR}/
+   DESTINATION ${FILESDIR}/cfg
    COMPONENT headers)
+
+install(FILES ${platforms}
+   DESTINATION ${FILESDIR}/platforms
+   COMPONENT headers)
+

=== gui/CMakeLists.txt ===
if (BUILD_GUI)

    set(CMAKE_AUTOMOC ON)
    if (${CMAKE_BUILD_TYPE} STREQUAL "Release")
        add_definitions(-DQT_NO_DEBUG)
        add_definitions(-DQT_NO_DEBUG_OUTPUT)
        add_definitions(-DQT_NO_WARNING_OUTPUT)
    else()
        add_definitions(-DQT_DEBUG)
    endif()

    include_directories(${PROJECT_SOURCE_DIR}/lib/)
    include_directories(SYSTEM ${PROJECT_SOURCE_DIR}/externals/tinyxml/)

    file(GLOB hdrs "*.h")
    file(GLOB srcs "*.cpp")
    file(GLOB uis  "*.ui")
    file(GLOB tss  "*.ts")
    QT5_WRAP_UI(uis_hdrs ${uis})
    QT5_ADD_RESOURCES(resources "gui.qrc")
    QT5_ADD_TRANSLATION(qms ${tss})

    add_executable(cppcheck-gui ${hdrs} ${srcs} ${uis_hdrs} ${resources} ${qms} $<TARGET_OBJECTS:lib_objs> $<TARGET_OBJECTS:tinyxml_objs> $<TARGET_OBJECTS:simplecpp_objs>)
    if (HAVE_RULES)
        target_link_libraries(cppcheck-gui pcre)
    endif()
    target_link_libraries(cppcheck-gui Qt5::Core Qt5::Gui Qt5::Widgets Qt5::PrintSupport)
    if(WITH_QCHART)
        target_compile_definitions (cppcheck-gui PRIVATE HAVE_QCHART )
        target_link_libraries(cppcheck-gui Qt5::Charts)
    endif()

    install(TARGETS cppcheck-gui RUNTIME DESTINATION ${CMAKE_INSTALL_FULL_BINDIR} COMPONENT applications)
    install(FILES ${qms} DESTINATION ${CMAKE_INSTALL_FULL_BINDIR} COMPONENT applications)

    install(FILES cppcheck-gui.desktop DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)

    # icons
    install(FILES cppcheck-gui.svg DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps)
    install(FILES cppcheck-gui.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/64x64/apps)

    set(CMAKE_AUTOMOC OFF)

endif()

=== lib/CMakeLists.txt ===
include_directories(SYSTEM ${PROJECT_SOURCE_DIR}/externals/)
include_directories(SYSTEM ${PROJECT_SOURCE_DIR}/externals/tinyxml/)
include_directories(${PROJECT_SOURCE_DIR}/externals/simplecpp/)

file(GLOB_RECURSE hdrs "*.h")
file(GLOB_RECURSE srcs "*.cpp")

function(build_src output filename)
    get_filename_component(file ${filename} NAME)
    set(outfile ${CMAKE_CURRENT_BINARY_DIR}/build/mc_${file})
    set(${output} ${${output}} ${outfile} PARENT_SCOPE)
    if (${USE_MATCHCOMPILER} STREQUAL "Verify")
        set(verify_option "--verify")
    endif()
    add_custom_command(
        OUTPUT ${outfile}
        COMMAND ${PYTHON_EXECUTABLE} "${PROJECT_SOURCE_DIR}/tools/matchcompiler.py" 
                --read-dir="${CMAKE_CURRENT_SOURCE_DIR}" 
                --prefix="mc_" 
                --line 
                ${verify_option} 
                ${file}
        DEPENDS ${file} 
        DEPENDS ${PROJECT_SOURCE_DIR}/tools/matchcompiler.py
    )
    set_source_files_properties(${outfile} PROPERTIES GENERATED TRUE)
endfunction()

foreach(file ${srcs})
    build_src(srcs_build ${file})
endforeach()

if (NOT ${USE_MATCHCOMPILER_OPT} STREQUAL "Off")
    set(srcs_lib ${srcs_build})
else()
    set(srcs_lib ${srcs})
endif()

add_library(lib_objs OBJECT ${srcs_lib} ${hdrs})

=== oss-fuzz/Makefile ===
#
# fuzzer clients
# ====================
#
# Local libfuzzer client:
# make CXX=clang++-6.0 CXXFLAGS="-fsanitize=address" fuzz-client

CPPCHECK_DIR=..
INCLUDE_DIR=-I ${CPPCHECK_DIR}/lib -I ${CPPCHECK_DIR}/externals/simplecpp -I ${CPPCHECK_DIR}/externals/tinyxml -I ${CPPCHECK_DIR}/externals
SRC_FILES=main.cpp type2.cpp ${CPPCHECK_DIR}/externals/simplecpp/simplecpp.cpp ${CPPCHECK_DIR}/externals/tinyxml/tinyxml2.cpp ${CPPCHECK_DIR}/lib/*.cpp

all:	oss-fuzz-client	translate

oss-fuzz-client:	main.cpp	type2.cpp	type2.h
	${CXX} -std=c++11 -g ${CXXFLAGS} -o oss-fuzz-client ${INCLUDE_DIR} ${SRC_FILES} -lFuzzingEngine

fuzz-client:	main.cpp	type2.cpp	type2.h
	${CXX} -std=c++11 -g -O1 ${CXXFLAGS} -fsanitize=fuzzer -o fuzz-client ${INCLUDE_DIR} ${SRC_FILES}

translate:	translate.cpp	type2.cpp	type2.h
	g++ -o translate type2.cpp translate.cpp

clean:
	rm -f oss-fuzz-client fuzz-client translate

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,15 @@
 if (BUILD_TESTS)
+
+    cmake_policy(SET CMP0064 NEW)
+    cmake_policy(SET CMP0057 NEW)
+
+    include(CTest)
+
+    find_package(Threads REQUIRED)
+    include(ProcessorCount)
+    ProcessorCount(N)
+    set(CTEST_PARALLEL_LEVEL ${N} CACHE STRING "CTest parallel level")
+    add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND} --output-on-failure -j ${CTEST_PARALLEL_LEVEL} -C ${CMAKE_CFG_INTDIR} --timeout 90)
 
     include_directories(${PROJECT_SOURCE_DIR}/lib/ ${PROJECT_SOURCE_DIR}/cli/)
     include_directories(SYSTEM ${PROJECT_SOURCE_DIR}/externals/tinyxml)
@@ -24,10 +35,95 @@
     endif()
 
     add_dependencies(testrunner copy_cfg)
+    add_dependencies(check testrunner cppcheck)
 
-    add_test(NAME testrunner COMMAND testrunner WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
+    set(SKIP_TESTS "" CACHE STRING "A list of tests to skip")
 
-    add_custom_target(check COMMAND $<TARGET_FILE:testrunner> -q WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
-    add_dependencies(check testrunner)
+    function(add_fixture NAME)
+        if (${NAME} IN_LIST SKIP_TESTS)
+        else()
+            add_test(NAME ${NAME} COMMAND testrunner ${NAME} WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
+        endif()
+    endfunction()
 
+    function(fixture_cost NAME COST)
+        if(TEST ${NAME})
+            set_tests_properties(${NAME} PROPERTIES COST ${COST})
+        endif()
+    endfunction()
+
+    foreach(SRC ${srcs})
+        file(STRINGS ${SRC} FIXTURE_LINE REGEX "TestFixture\\(" LIMIT_COUNT 1)
+        if(FIXTURE_LINE MATCHES "TestFixture\\(\"([a-zA-z0-9]+)\"\\)")
+            add_fixture(${CMAKE_MATCH_1})
+        endif()
+    endforeach()
+
+    function(add_cfg CFG_TEST)
+        set(options INCONCLUSIVE)
+        set(oneValueArgs PLATFORM NAME)
+        set(multiValueArgs LIBRARY)
+
+        cmake_parse_arguments(PARSE "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})
+        if(PARSE_LIBRARY)
+            string(REPLACE ";" "," LIBRARY "${PARSE_LIBRARY}")
+        else()
+            get_filename_component(LIBRARY ${CFG_TEST} NAME_WE)
+        endif()
+        set(PLATFORM unix64)
+        if(PARSE_PLATFORM)
+            set(PLATFORM ${PARSE_PLATFORM})
+        endif()
+        if(PARSE_NAME)
+            set(TEST_NAME ${PARSE_NAME})
+        else()
+            string(MAKE_C_IDENTIFIER ${CFG_TEST} TEST_NAME)
+        endif()
+        set(INCONCLUSIVE)
+        if(PARSE_INCONCLUSIVE)
+            set(INCONCLUSIVE "--inconclusive")
+        endif()
+        if (${TEST_NAME} IN_LIST SKIP_TESTS)
+        else()
+            add_test(NAME cfg-${TEST_NAME} 
+                    COMMAND $<TARGET_FILE:cppcheck>
+                    --check-library
+                    --platform=${PLATFORM}
+                    --library=${LIBRARY}
+                    --enable=information
+                    --enable=style
+                    --error-exitcode=1
+                    --suppress=missingIncludeSystem
+                    --inline-suppr 
+                    ${INCONCLUSIVE}
+                    ${CMAKE_CURRENT_SOURCE_DIR}/cfg/${CFG_TEST}
+            )
+        endif()
+    endfunction()
+    add_cfg(boost.cpp INCONCLUSIVE)
+    add_cfg(bsd.c)
+    add_cfg(gnu.c LIBRARY posix gnu)
+    add_cfg(googletest.cpp)
+    add_cfg(gtk.c)
+    add_cfg(libcurl.c)
+    add_cfg(lua.c)
+    add_cfg(openmp.c)
+    add_cfg(posix.c)
+    add_cfg(python.c)
+    add_cfg(qt.cpp)
+    add_cfg(sqlite3.c INCONCLUSIVE)
+    add_cfg(std.c INCONCLUSIVE)
+    add_cfg(std.cpp INCONCLUSIVE)
+    add_cfg(windows.cpp INCONCLUSIVE NAME windows32A PLATFORM win32A)
+    add_cfg(windows.cpp INCONCLUSIVE NAME windows32W PLATFORM win32W)
+    add_cfg(windows.cpp INCONCLUSIVE NAME windows64 PLATFORM win64)
+    add_cfg(wxwidgets.cpp INCONCLUSIVE)
+
+    # Set cost of the more expensive tests to help improve parallel scheduling
+    # of tests
+    fixture_cost(TestIO 20)
+    fixture_cost(cfg-std_c 8)
+    fixture_cost(TestThreadExecutor 5)
+    fixture_cost(TestLeakAutoVar 4)
+    fixture_cost(TestTokenizer 4)
 endif()

=== tools/triage/CMakeLists.txt ===
if (BUILD_GUI AND BUILD_TESTS)
    set(CMAKE_AUTOMOC ON)
    if (${CMAKE_BUILD_TYPE} STREQUAL "Release")
        add_definitions(-DQT_NO_DEBUG)
        add_definitions(-DQT_NO_DEBUG_OUTPUT)
        add_definitions(-DQT_NO_WARNING_OUTPUT)
    else()
        add_definitions(-DQT_DEBUG)
    endif()

    file(GLOB hdrs "*.h")
    file(GLOB srcs "*.cpp")
    file(GLOB uis  "*.ui")
    qt5_wrap_ui(uis_hdrs ${uis})

    add_executable(
        triage
        ${hdrs}
        ${srcs}
        ${uis_hdrs}
        ${PROJECT_SOURCE_DIR}/gui/codeeditorstyle.cpp
        ${PROJECT_SOURCE_DIR}/gui/codeeditor.cpp)
    target_include_directories(triage PUBLIC ${PROJECT_SOURCE_DIR}/gui/)
    target_link_libraries(triage Qt5::Core Qt5::Gui Qt5::Widgets)

    set(CMAKE_AUTOMOC OFF)
endif()

=== debian/changelog ===
cppcheck (1.90-4build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:11:55 +0100

cppcheck (1.90-4) unstable; urgency=medium

  * Re-add cppcheck-htmlreport which got lost in 1.90-2 (Closes: #949944).
  * Update Standards-Version to 4.5.0 (no changes needed).

 -- Joachim Reichel <reichel@debian.org>  Mon, 27 Jan 2020 22:38:54 +0100

cppcheck (1.90-3) unstable; urgency=medium

  * Improve debian/rules (thanks to Lisandro Meyer), in particular fix
    for parallel builds and simplifications (Closes: #949181).
  * Add versioned Depends: cppcheck to cppcheck-gui due to the cfg files
    (Closes: #949199, LP: #1854552).
  * Remove unused debian/clean and debian/dirs.

 -- Joachim Reichel <reichel@debian.org>  Sat, 18 Jan 2020 10:22:50 +0100

cppcheck (1.90-2) unstable; urgency=medium

  * Use build system based on cmake which supports generation of *.qm files
    required for translations (Closes: #948885).
  * Recreate all patches as necessary. This should also fix usage of addons.
  * Enable QCharts support (Closes: #948888).

 -- Joachim Reichel <reichel@debian.org>  Thu, 16 Jan 2020 22:12:42 +0100

cppcheck (1.90-1) unstable; urgency=medium

  * New upstream release.
  * Remove patch bug-9353 (fixed upstream).
  * Remove debian/source/include-binaries (unnecessary, added by accident
    in 1.77-1).
  * Use debhelper compat version 12 (no changes needed).

 -- Joachim Reichel <reichel@debian.org>  Mon, 30 Dec 2019 10:07:19 +0100

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,11 @@
 Section: devel
 Priority: optional
 Maintainer: Joachim Reichel <reichel@debian.org>
-Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.15.7~), xsltproc, docbook-xsl,
-  docbook-xml, libpcre3-dev, libtinyxml2-dev (>= 6.2.0+dfsg), qt5-qmake, qtbase5-dev,
-  qtbase5-dev-tools, gdb, dh-python, python3-all
-Standards-Version: 4.4.1
+Build-Depends: debhelper-compat (= 12), dh-sequence-python3, dpkg-dev (>= 1.15.7~),
+  xsltproc, docbook-xsl, docbook-xml, cmake,libtinyxml2-dev (>= 6.2.0+dfsg),
+  libpcre3-dev, qt5-qmake, qtbase5-dev, qtbase5-dev-tools, qttools5-dev,
+  libqt5charts5-dev, gdb, dh-python, python3-all
+Standards-Version: 4.5.0
 Rules-Requires-Root: no
 Homepage: http://sourceforge.net/p/cppcheck/wiki/Home/
 
@@ -51,7 +52,7 @@
 
 Package: cppcheck-gui
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}, cppcheck (= ${binary:Version})
 Suggests: python3, clang
 Description: tool for static C/C++ code analysis (GUI)
  Cppcheck is a command-line tool that tries to detect bugs that your

=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE=1

# for DEB_VERSION_UPSTREAM
include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export QT_SELECT := qt5

# See http://wiki.debian.org/Hardening#Notes_for_packages_using_CMake
CFLAGS   := $(CFLAGS) $(CPPFLAGS)
CXXFLAGS := $(CXXFLAGS) $(CPPFLAGS)

%:
	dh $@ --buildsystem=cmake --builddirectory=build

override_dh_auto_configure:
	QTDIR= dh_auto_configure -- -DCMAKE_BUILD_TYPE=Release \
	  -DUSE_MATCHCOMPILER=ON -DBUILD_TESTS=ON -DBUILD_GUI=ON -DWITH_QCHART=ON \
	  -DHAVE_RULES=ON -DFILESDIR=/usr/lib/$(DEB_HOST_MULTIARCH)/cppcheck

override_dh_auto_build:
	dh_auto_build
	xsltproc -''-nonet -''-param man.charmap.use.subset "0" --output build/cppcheck.1 \
	  /usr/share/sgml/docbook/stylesheet/xsl/nwalsh/manpages/docbook.xsl \
	  man/cppcheck.1.xml
	sed -e "s/1.70/$(DEB_VERSION_UPSTREAM)/" debian/cppcheck-htmlreport.1.in \
	  >build/cppcheck-htmlreport.1

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	build/bin/testrunner
endif

override_dh_auto_install:
	dh_auto_install
	install htmlreport/cppcheck-htmlreport $(CURDIR)/debian/tmp/usr/bin
	install -d $(CURDIR)/debian/tmp/usr/share/man/man1
	install build/cppcheck.1 $(CURDIR)/debian/tmp/usr/share/man/man1
	install build/cppcheck-htmlreport.1 $(CURDIR)/debian/tmp/usr/share/man/man1
	dh_install --sourcedir=debian/tmp

# workaround for "dwz: debian/cppcheck/usr/bin/cppcheck: Unknown DWARF DW_OP_255"
override_dh_dwz:
	dh_dwz -Xcppcheck
